返回顶部

Codeforces Round #610 (Div. 2) B2. K for the Price of One (Hard Version) (贪心,DP)

  • 题意:有\(n\)个物品,每个物品的价值是\(a_i\),每个物品只有一个,假如你买了价值为\(a_x\)的物品,那么你可以选择\(k\)个价值不大于\(a_x\)的物品一块打包送给你,但是必须要\(k\)个才行,不能多不能少,你现在有\(p\)块钱,问你最多能买多少物品.

  • 题解:先对物品排序,假如我们要买\(x\)个物品,不难发现,买前\(x\)个一定是最优的,有了这样的贪心策略后,就可以很容易线性DP了,我们设\(dp[i]\)表示买前\(i\)个物品最少要花多少钱,因为如果要打包的话,必须选择\(k\)个,因此对于前\(k\)个物品\(dp[i]=a[i]\),当\(i\ge k\)时,我们就可以打包买了,\(dp[i]=min(dp[i-1],dp[i-k])+a[i]\),如果\(dp[i]<=p\),我们就更新答案.

  • 代码:

    #include <bits/stdc++.h>
    #define ll long long
    #define fi first
    #define se second
    #define pb push_back
    #define me memset
    #define rep(a,b,c) for(int a=b;a<=c;++a)
    #define per(a,b,c) for(int a=b;a>=c;--a)
    const int N = 1e6 + 10;
    const int mod = 1e9 + 7;
    const int INF = 0x3f3f3f3f;
    using namespace std;
    typedef pair<int,int> PII;
    typedef pair<ll,ll> PLL;
    ll gcd(ll a,ll b) {return b?gcd(b,a%b):a;}
    ll lcm(ll a,ll b) {return a/gcd(a,b)*b;}
     
    int a[N];
    int dp[N];
     
    int main() {
        ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    	int _;
    	cin>>_;
    	while(_--){
    		int n,p,k;
    		cin>>n>>p>>k;
    		rep(i,1,n) cin>>a[i];
    		me(dp,0,sizeof(dp));
     
    		sort(a+1,a+1+n);
    	
    		int ans=0;
    		rep(i,1,n){
    			if(i<k){
    				dp[i]=dp[i-1]+a[i];
    			}	
    			else dp[i]=min(dp[i-1],dp[i-k])+a[i];
    			if(dp[i]<=p) ans=max(ans,i);
    		}
    	
    		cout<<ans<<'\n';
    		
    	}
     
        return 0;
    }
    
posted @ 2021-04-01 20:04  Rayotaku  阅读(51)  评论(0编辑  收藏  举报